/* ****************************************************************************
 *    File Name : 2532.D
 *    Pin num 	: 24 pin
 *    Size 	: 512K (FFF)	(A0..A11	D0..D7)
 *    Last Modify Date : 91. 3. 20
 *
 * ----------------------------------------------------------------------------
 *    Vpp:25.0   Vcc:5.0   Dur:50ms 
 * ---------------------------------------------------------------------------- 
 *    Device 	:  TI		2532	
 * ************************************************************************** */
declaration
   dataunit : byte;
   functions
      Program
      Read
      Verify
      Blank_Check
      Data_Compare
      Auto
   ;
   Manufacturers
      TI	
   ;
   Devices
      D2532		
   ;
   chips = A7, A6, A5, A4, A3, A2,  A1,  A0,     D0,  D1, D2, GND,
	   D3, D4, D5, D6, D7, A11, A10, PD:PGM, Vpp, A9, A8, Vcc
   ;
   $v2 = Vpp;
   $v3 = Vcc;
endd

/* -----------------------------------------------------------------------
 * Failf () ---> Fail address setting
 * ----------------------------------------------------------------------- */
int Failf (hwhb, hwlb, lwhb, lwlb, tmp)
int hwhb, hwlb, lwhb, lwlb, tmp;
{
int high, low;

   high = (hwhb << 8) | hwlb;
   low  = (lwhb << 8) | lwlb;

   @Fail high, low, tmp;
}
/* -----------------------------------------------------------------------
 * init () ---> Initial processing
 * ----------------------------------------------------------------------- */
int     init (vol2, vol3)
voltage vol2, vol3;
{
   @Vout 2, vol2;            /* Voltage Source #2 */
   @Vout 3, vol3;            /* Voltage Source #3 */
   @Out GND      , @G;       /* Ground output */
   @Delay 10	 , @ms;

   @Out D [0..7] , @Z;      
   @Out A [0..7] , @W;      
   @Out A [8..11], @W;      
   @Out Vcc	 , @W;
   @Out Vpp	 , @W;
   @Out PGM	 , @W;

   @Out Vcc	 , @H;   
   @Out Vpp	 , @H;
   @Out PGM      , @H;      

   @Out Vcc	 , @O;       /* Vcc Enable */
   @Delay 100	 , @us;
}
/* -----------------------------------------------------------------------
 * InitProcess () ---> Initial Buffer | Voltage source
 * ----------------------------------------------------------------------- */
int InitProcess ()
{
   if (FUNCTION != Program) init ( 5.0 , 5.0 );
   else 		    init (25.0 , 5.0 );
}
/* -----------------------------------------------------------------------
 * read () ---> read processing
 * ----------------------------------------------------------------------- */
int read (row)
int	row;
{
int  hwhb, hwlb, lwhb, lwlb;	/* eaddr : end address */
int  tmp, tmp2, sll, ell, slh, elh;

   lwlb = lwhb = hwhb = hwlb = 0;
   sll = ell = slh = elh = tmp = tmp2 = 0;
   
   @Set B_HADDR, B_LADDR;
   @Inc __B_START__;
   
   if (FUNCTION == Read)
   {
   	@Display 26, row, "Reading...";	
   	@CheckSumON;
   }
   else if (FUNCTION == Verify)		@Display 26, row, "Verifying...";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Checking...";
   else 			        @Display 26, row, "Data Comparing...";
   
   for ( hwhb= S_HWHB ; hwhb<=E_HWHB; hwhb++ )
   {
      @Display 64, 9, hwhb;
      for ( hwlb= S_HWLB; hwlb<= E_HWLB ; hwlb++ )
      {
	 @Display 66, 9, hwlb;
	 
	 if (hwlb == S_HWLB) slh = S_LWHB;
         else                slh = 0;
         if (hwlb == E_HWLB) elh = E_LWHB;
         else                elh = 0xFF;
         
	 for ( lwhb=slh;lwhb<=elh; lwhb++)
         {
	    @Display 68, 9, lwhb;
	    @Out A [8..11], lwhb;   /* Output High word address */
	    
	    if (lwhb == S_LWHB) sll = S_LWLB;
            else                sll = 0;
            if (lwhb == E_LWHB) ell = E_LWLB;
            else                ell = 0xFF;

	    for ( lwlb=sll ; lwlb<=ell; lwlb++)
	    {
	       @Out A [0..7], lwlb;    /* Low  byte address output */
	       
	       @Out PGM     , @L;
	       @In  D [0..7], tmp;
	       @Out PGM     , @H;
	       
	       if      (FUNCTION == Read)          @Load tmp;
	       else if (FUNCTION == Data_Compare) 
	       {
	       	    @Store   tmp2;
	       	    @Compare tmp, tmp2;
	       }
	       else if (FUNCTION == Blank_Check)
	       {
		    if (tmp != 0xFF)	Failf(hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       else if (FUNCTION == Verify)
	       {
		   @Store tmp2;
		   if (tmp != tmp2)  Failf (hwhb, hwlb, lwhb, lwlb, tmp);
	       }
	       if (FUNCTION != Blank_Check)	@Inc SPLIT;
            }
	 }
      }
   }
   if 	   (FUNCTION == Read)		@Display 26, row, "Read OK!   ";
   else if (FUNCTION == Verify)		@Display 26, row, "Verification OK!";
   else if (FUNCTION == Blank_Check)	@Display 26, row, "Blank Check OK!  ";
   else 			        @Display 26, row, "Data Comparison OK!";
}
/* -----------------------------------------------------------------------
 * program() ---> Control main
 * ----------------------------------------------------------------------- */
int	program (row, kind)
int	row, kind;
{
int  hwhb, hwlb, lwhb, lwlb;
int  sll, ell, slh, elh;
int  failcnt, tmp, tmp2;

   failcnt = tmp = tmp2 = 0;
   lwlb = lwhb = hwhb = hwlb = slh = elh = sll = ell = 0;
   
   @Set B_HADDR, B_LADDR;
   @Inc	 __B_START__;
   
   @Display 26, row, "Programming...";
   
   @Out D [0..7] , @W;

   for ( hwhb=0 /* S_HWHB */; hwhb<=0 /* E_HWHB */; hwhb++ )
   {
       @Display 64, 9, hwhb;

       for ( hwlb=S_HWLB; hwlb<=E_HWLB; hwlb++ )
       {
	   @Display 66, 9, hwlb;
	   
	   if (hwlb == S_HWLB) slh = S_LWHB;
           else                slh = 0;
           if (hwlb == E_HWLB) elh = E_LWHB;
           else                elh = 0xFF;	       
           
	   for ( lwhb=slh; lwhb<=elh; lwhb++)
	   {
	       @Display 68, 9, lwhb;
	       @Out A [8..11], lwhb;   /* Output High word address */
	       
	       if (lwhb == S_LWHB) sll = S_LWLB;
               else                sll = 0;
               if (lwhb == E_LWHB) ell = E_LWLB;
               else                ell = 0xFF;	           

	       for ( lwlb=sll; lwlb<=ell; lwlb++)
	       {
		  @Store tmp;
		  
		  if (tmp == 0xFF)	
		  {
		      @Inc  SPLIT;
		      continue;
		  }

		  @Out Vpp     , @O;	          		  
	          @Out A [0..7], lwlb;
		  @Out D [0..7], tmp;
		  @Out PGM     , @L;
		  @Delay 50    , @Ms;
		  @Out PGM     , @H;

		  /* -------- Verify ----------- */
		  @Out Vpp     , @F;		  
                  @Out D [0..7], @Z;
		  @Out PGM     , @L;                  
		  @In  D [0..7], tmp2;
		  
		  @Out D [0..7], @W;
		  @Out PGM     , @H;
		  
		  if (tmp != tmp2)
                  {
		     if (failcnt > 25) 
		       	Failf (hwhb, hwlb, lwhb, lwlb, tmp2);
		     else
		     {
			++ failcnt;
			lwlb--;
		     }
                  }
		  else
		  {
                      failcnt = 0;
		      @Inc SPLIT;
		  }
               }
	   }
       }
   }
   @Display 26, row, "Program OK!   ";
   if (kind == 0)	row = 7;
   else			row = 8;
   FUNCTION = Verify;
   InitProcess ();
   read (row);		/*  Verify  */   
}
/* -----------------------------------------------------------------------
 * main () ---> Control main
 * ----------------------------------------------------------------------- */
int main ()
{
   InitProcess();

   if ( FUNCTION == Auto )
   {
	FUNCTION = Blank_Check;
	read (6);
	
	FUNCTION = Program;
	InitProcess ();
	program (7,1);
   }
   else if ( FUNCTION == Program ) program(6, 0);
   else 			   read (6);
}
/* ---------------------------- End of program --------------------------- */  